#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Flags And Immunity]",
	author	= "wS",
	version = "1.2.6"
};

#define ITEM_NAME "flags_and_immunity"
#define IMMUNITY_NOT_CHANGED -5

new bool:g_bGived[MAXPLAYERS + 1];					// true = внесли изменения в права
new bool:g_bFlagAcces[MAXPLAYERS + 1][AdminFlag];	// какие флаги нужно выдать
new bool:g_bFlagGived[MAXPLAYERS + 1][AdminFlag];	// true = флаг выдали мы (надо отобрать при выходе) | false = флаг был
new g_DefImmunity[MAXPLAYERS + 1] = {IMMUNITY_NOT_CHANGED, ...}; // какой иммунитет был
new g_VipImmunity[MAXPLAYERS + 1];					// какой иммунитет нужно выдать
new Handle:g_hTimer = INVALID_HANDLE;				// повторная установка флагов/иммунитета из-за конфликта с другими плагинами

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_SELECT))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);

	new Handle:hCvar = CreateConVar("vip_flags_immunity_timer", "0", "Установка флагов/иммунитета каждые 'x' сек из-за конфликта с другими плагинами (0 = откл)");
	new Float:s = GetConVarFloat(hCvar);
	if (s > 0.0) g_hTimer = CreateTimer(s, flags_immunity_timer, _, TIMER_REPEAT);
	HookConVarChange(hCvar, cvar_timer);
	AutoExecConfig(true, "flags_and_immunity", "vip/modules/flags_and_immunity");
}

public cvar_timer(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	if (g_hTimer != INVALID_HANDLE) KillTimer(g_hTimer);
	new Float:s = StringToFloat(NewValue);
	g_hTimer = s > 0.0 ? CreateTimer(s, flags_immunity_timer, _, TIMER_REPEAT) : INVALID_HANDLE;
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	return FlagsAndImmunityToString(client, ItemValue, ItemValueSize);
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	return UpdateAccess(client, ItemValue);
}

stock VipGiveAction:UpdateAccess(client, String:ItemValue[ITEM_INFO_LENGTH])
{
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;
	
	// flags_and_immunity : flags : immunity
	
	decl String:buffer[2][52];
	buffer[1][0] = 0;
	if (ExplodeString(ItemValue, ":", buffer, sizeof(buffer), sizeof(buffer[])) < 1) // "flags:immunity" or "flags"
		return VGA_BadValue;
		
	new x						= TrimString(buffer[0]);
	new AdminId:id				= GetUserAdmin(client);
	new bool:bNeedSetFlags		= false;
	new bool:bNeedSetImmunity	= false;

	// flags
	
	// Отбираем флаги, которые выдавали.
	TakeGivedFlags(client, id);
	
	decl AdminFlag:flag;
	for (new i = 0; i < x; i++)
	{
		if (FindFlagByChar(CharToLower(buffer[0][i]), flag))
		{
			g_bFlagAcces[client][flag] = true;
			bNeedSetFlags = true;
		}
	}

	// immunity (по идее от 1 до 99)
	if ((x = StringToInt(buffer[1])) > 0 && x < 100 && g_VipImmunity[client] != x)
	{
		g_VipImmunity[client] = x;
		new curr_immunity = id == INVALID_ADMIN_ID ? 0 : GetAdminImmunityLevel(id); // текущий иммунитет
		if (g_VipImmunity[client] != curr_immunity)
		{
			if (g_DefImmunity[client] == IMMUNITY_NOT_CHANGED) g_DefImmunity[client] = curr_immunity;
			if (g_DefImmunity[client] < g_VipImmunity[client]) bNeedSetImmunity = true;
		}
	}

	if (!bNeedSetFlags && !bNeedSetImmunity)
		return VGA_Stop;

	if (id == INVALID_ADMIN_ID)
	{
		id = CreateAdmin("vip");
		SetUserAdmin(client, id, true);
	}

	if (bNeedSetFlags)
	{
		bNeedSetFlags = false;
		x = GetAdminFlags(id, Access_Real);
		for (flag = AdminFlag:0; flag < AdminFlag; flag++)
		{
			if (g_bFlagAcces[client][flag] && !(FlagToBit(flag) & x))
			{
				SetAdminFlag(id, flag, true);
				g_bFlagGived[client][flag] = true;
				bNeedSetFlags = true;
			}
		}
		if (!bNeedSetFlags && !bNeedSetImmunity) // у игрока уже есть все флаги, которые мы собирались давать
			return VGA_Stop;
	}

	if (bNeedSetImmunity)
		SetAdminImmunityLevel(id, g_VipImmunity[client]);

	g_bGived[client] = true; // true = мы внесли изменения в права
	
	FlagsAndImmunityToString(client, ItemValue, ITEM_INFO_LENGTH);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, true, ItemValue, ITEM_INFO_LENGTH);
	
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	if (!g_bGived[client])
		return;

	g_bGived[client] = false;
	decl AdminId:id;

	if (!IsClientInGame(client) || (id = GetUserAdmin(client)) == INVALID_ADMIN_ID)
	{
		for (new AdminFlag:flag; flag < AdminFlag; flag++)
		{
			g_bFlagAcces[client][flag] = false;
			g_bFlagGived[client][flag] = false;
		}
		g_DefImmunity[client] = IMMUNITY_NOT_CHANGED;
		g_VipImmunity[client] = 0;
		return;
	}

	// Отбираем флаги, которые выдавали.
	// Если не отобрать и это не временный админ, то флаги у него останутся до sm_reloadadmins.
	TakeGivedFlags(client, id);

	// Возвращаем прежний иммунитет
	if (g_DefImmunity[client] != IMMUNITY_NOT_CHANGED)
		SetAdminImmunityLevel(id, g_DefImmunity[client]);

	g_DefImmunity[client] = IMMUNITY_NOT_CHANGED;
	g_VipImmunity[client] = 0;
	
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, false);
}

public OnPluginPauseChange(bool:pause) { if (pause) VIP_TakeAccessAll(); }
public OnPluginEnd() VIP_TakeAccessAll();

stock VIP_TakeAccessAll()
{
	for (new client = 1; client <= MaxClients; client++)
		VIP_TakeAccess(client, 0, false);
}

public OnClientDisconnect(client)
	VIP_TakeAccess(client, 0, false);

//

new Handle:g_hT = INVALID_HANDLE;

public OnRebuildAdminCache(AdminCachePart:part) // учитываем sm_reloadadmins
{
	if (part == AdminCache_Admins)
	{
		if (g_hT) KillTimer(g_hT);
		g_hT = CreateTimer(1.0, timer_CallBack);
	}
}

public Action:timer_CallBack(Handle:timer)
{
	g_hT = INVALID_HANDLE;
	wS_ReturnAccess();
	return Plugin_Stop;
}

public Action:flags_immunity_timer(Handle:timer)
{
	wS_ReturnAccess();
	return Plugin_Continue;
}

wS_ReturnAccess()
{
	decl AdminId:id, AdminFlag:flag;
	for (new client = 1; client <= MaxClients; client++)
	{
		if (g_bGived[client] && IsClientInGame(client))
		{
			if ((id = GetUserAdmin(client)) == INVALID_ADMIN_ID)
			{
				id = CreateAdmin("vip");
				SetUserAdmin(client, id, true);
			}
			for (flag = AdminFlag:0; flag < AdminFlag; flag++)
			{
				if (g_bFlagGived[client][flag])
				{
					SetAdminFlag(id, flag, true);
				}
				else if (g_bFlagAcces[client][flag] && !GetAdminFlag(id, flag))
				{
					g_bFlagGived[client][flag] = true;
					SetAdminFlag(id, flag, true);
				}
			}
			if (g_VipImmunity[client] > 0 && g_VipImmunity[client] > GetAdminImmunityLevel(id))
				SetAdminImmunityLevel(id, g_VipImmunity[client]);
		}
	}
}

//

stock wS_AdminFlagToString(AdminFlag:a, String:b[], c)
{
	if (a == Admin_Reservation)	return strcopy(b, c, "reservation(a)");
	if (a == Admin_Generic)		return strcopy(b, c, "generic(b)");
	if (a == Admin_Kick)		return strcopy(b, c, "kick(c)");
	if (a == Admin_Ban)			return strcopy(b, c, "ban(d)");
	if (a == Admin_Unban)		return strcopy(b, c, "unban(e)");
	if (a == Admin_Slay)		return strcopy(b, c, "slay(f)");
	if (a == Admin_Changemap)	return strcopy(b, c, "changemap(g)");
	if (a == Admin_Convars)		return strcopy(b, c, "cvars(h)");
	if (a == Admin_Config)		return strcopy(b, c, "config(i)");
	if (a == Admin_Chat)		return strcopy(b, c, "chat(j)");
	if (a == Admin_Vote)		return strcopy(b, c, "vote(k)");
	if (a == Admin_Password)	return strcopy(b, c, "password(l)");
	if (a == Admin_RCON)		return strcopy(b, c, "rcon(m)");
	if (a == Admin_Cheats)		return strcopy(b, c, "cheats(n)");
	if (a == Admin_Custom1)		return strcopy(b, c, "custom1(o)");
	if (a == Admin_Custom2)		return strcopy(b, c, "custom2(p)");
	if (a == Admin_Custom3)		return strcopy(b, c, "custom3(q)");
	if (a == Admin_Custom4)		return strcopy(b, c, "custom4(r)");
	if (a == Admin_Custom5)		return strcopy(b, c, "custom5(s)");
	if (a == Admin_Custom6)		return strcopy(b, c, "custom6(t)");
	if (a == Admin_Root)		return strcopy(b, c, "ROOT(z)");
	b[0] = 0;
	return 0; // wtf
}

stock bool:FlagsAndImmunityToString(client, String:ItemValue[], ItemValueSize)
{
	new index = 0;
	for (new AdminFlag:flag, c; flag < AdminFlag; flag++)
	{
		if (g_bFlagAcces[client][flag] && FindFlagChar(flag, c))
			ItemValue[index++] = c;
	}
	ItemValue[index] = 0;
	if (!ItemValue[0] && !g_VipImmunity[client]) return false;
	Format(ItemValue, ItemValueSize, "%s:%d",
		ItemValue[0] ? ItemValue : "0",
		g_VipImmunity[client] > g_DefImmunity[client] ? g_VipImmunity[client] : g_DefImmunity[client]); // "abcd:99"
	return true;
}

stock TakeGivedFlags(client, AdminId:id)
{
	for (new AdminFlag:flag; flag < AdminFlag; flag++)
	{
		if (g_bFlagAcces[client][flag])
		{
			g_bFlagAcces[client][flag] = false;
			if (g_bFlagGived[client][flag])
			{
				g_bFlagGived[client][flag] = false;
				if (id != INVALID_ADMIN_ID) SetAdminFlag(id, flag, false);
			}
		}
	}
}

public VIP_MenuSelect(client, ItemID, const String:ItemName[], const String:ItemValue[])
{
	new Handle:panel = CreatePanel();
	decl String:text[64];
	
	new AdminId:id = GetUserAdmin(client);
	FormatEx(text, sizeof(text), "Immunity (VIP): %d\nImmunity (current): %d\n \n",
		g_VipImmunity[client], id != INVALID_ADMIN_ID ? GetAdminImmunityLevel(id) : 0);
	SetPanelTitle(panel, text);
	
	for (new AdminFlag:flag; flag < AdminFlag; flag++)
	{
		if (g_bFlagAcces[client][flag] && wS_AdminFlagToString(flag, text, sizeof(text)))
			DrawPanelText(panel, text);
	}
	
	DrawPanelText(panel, " ");
	
	SetPanelCurrentKey(panel, 8);
	DrawPanelItem(panel, "<-");
	
	SetPanelCurrentKey(panel, VIP_GetServerType() == 1 ? 9 : 10);
	DrawPanelItem(panel, "Exit");
	
	SendPanelToClient(panel, client, panel_CallBack, 0);
	CloseHandle(panel);
}

public panel_CallBack(Handle:panel, MenuAction:action, client, item)
{
	if (action == MenuAction_Select)
	{
		if (item == 8)
		{
			if (!VIP_MenuFlood(client))
			{
				PLAY_EXIT_BACK_SOUND(client);
				VIP_ShowMenu(client);
			}
		}
		else {
			PLAY_EXIT_SOUND(client);
		}
	}
}